function b = subsref(oData,index)


if length(index)==1
    switch index(1).type
        case '()'
            switch index(1).subs{:}
                case 1
                    b=oData.T;
                case 2
                    b=oData.X;
                case 3
                    b=oData.ModelName;
                case 4
                    b=oData.Legend;
                case 5
                    b=oData.Output;
                case 6
                    b=oData.vk;
                case 7
                    b=oData.Volume;
                case 8
                    b=oData.Date;
                case 9
                    b=oData.IntegratorType;
                otherwise
                    error ('invalid index')
            end

        case '.'
            switch index(1).subs
                case 'ModelName'
                    b=oData.ModelName;
                case 'vk'
                    b=oData.vk;
                case 'X'
                    b=oData.X;
                case 'T'
                    b=oData.T;
                case 'Date'
                    b=oData.Date;
                case 'Output'
                    b=oData.Output;
                case 'Legend'
                    b=oData.Legend;
                case 'Volume'
                    b=oData.Volume;
                case 'Integrator'
                    b=oData.IntegratorType;
                otherwise
                    error ('invalid index')
            end

        case'{}'
            error ('cell array indexing not supported by data objects')
    end
    
elseif length(index)==2
    if index(1).subs=='X'
        switch index(2).type
            case '()'
                if length(index(2).subs)==1
                    switch index(2).subs{:}
                        case 1
                            b=oData.X.vX;
                        case 2
                            b=oData.X.dX;
                        case 3
                            b=oData.X.dk;
                        otherwise
                            error ('invalid index')
                    end
                    
                elseif length(index(2).subs)==2
                    if isnumeric(index(2).subs{1}); index(2).subs{1} = num2str(index(2).subs{1}); end
                    if isnumeric(index(2).subs{2}); index(2).subs{2} = num2str(index(2).subs{2}); end
                    eval(sprintf('b = oData.X(%s,%s);', index(2).subs{1}, index(2).subs{2}));
                    
                elseif length(index(2).subs)==3
                    if isnumeric(index(2).subs{1}); index(2).subs{1} = num2str(index(2).subs{1}); end
                    if isnumeric(index(2).subs{2}); index(2).subs{2} = num2str(index(2).subs{2}); end
                    if isnumeric(index(2).subs{3}); index(2).subs{3} = num2str(index(2).subs{3}); end
                    if sum([index(2).subs{1} index(2).subs{2} index(2).subs{3}]==':')==2
                        eval(sprintf('b(:,:) = oData.X(%s,%s,%s);', index(2).subs{1}, index(2).subs{2}, index(2).subs{3}));
                    else
                        eval(sprintf('b = oData.X(%s,%s,%s);', index(2).subs{1}, index(2).subs{2}, index(2).subs{3}));
                    end
                    
                else
                    error('use oData.X(:,:) to specify index')
                end

                    
            case '.'
                switch index(2).subs
                    case 'vX'
                        b=oData.X.vX;
                    case 'dX'
                        b=oData.X.dX;
                    case 'dk'
                        b=oData.X.dk;
                    otherwise
                        error ('invalid index')
                end
        end
    elseif index(1).subs=='T'
        if strcmp(index(2).type,'()') && length(index(2).subs)==1
            if isnumeric(index(2).subs{1}); index(2).subs{1} = num2str(index(2).subs{1}); end
            eval(sprintf('b = oData.T(%s);', index(2).subs{1}));
        else
            error('use oData.T(:) to specify index')
        end
    else
        error ('invalid index')
    end
    
elseif length(index)==3
    if index(1).subs=='X'
        if strcmp(index(2).subs,'vX') 
            if strcmp(index(3).type,'()') && length(index(3).subs)==2
                if isnumeric(index(3).subs{1}); index(3).subs{1} = num2str(index(3).subs{1}); end
                if isnumeric(index(3).subs{2}); index(3).subs{2} = num2str(index(3).subs{2}); end
                eval(sprintf('b = oData.X.vX(%s,%s);', index(3).subs{1}, index(3).subs{2}));
            else
                error('use (:,:,:) to specify index')
            end
        elseif strcmp(index(2).subs,'dX') 
            if strcmp(index(3).type,'()') && length(index(3).subs)==3
                if isnumeric(index(3).subs{1}); index(3).subs{1} = num2str(index(3).subs{1}); end
                if isnumeric(index(3).subs{2}); index(3).subs{2} = num2str(index(3).subs{2}); end
                if isnumeric(index(3).subs{3}); index(3).subs{3} = num2str(index(3).subs{3}); end
                if sum([strcmp(index(3).subs{1},':') strcmp(index(3).subs{2},':') strcmp(index(3).subs{3},':')])==2
                    eval(sprintf('b(:,:) = oData.X.dX(%s,%s,%s);', index(3).subs{1}, index(3).subs{2}, index(3).subs{3}));
                else
                    eval(sprintf('b = oData.X.dX(%s,%s,%s);', index(3).subs{1}, index(3).subs{2}, index(3).subs{3}));
                end
            else
                error('use (:,:,:) to specify index')
            end
            
        elseif strcmp(index(2).subs,'dk')
            if strcmp(index(3).type,'()') && length(index(3).subs)==3
                if isnumeric(index(3).subs{1}); index(3).subs{1} = num2str(index(3).subs{1}); end
                if isnumeric(index(3).subs{2}); index(3).subs{2} = num2str(index(3).subs{2}); end
                if isnumeric(index(3).subs{3}); index(3).subs{3} = num2str(index(3).subs{3}); end
                if sum([strcmp(index(3).subs{1},':') strcmp(index(3).subs{2},':') strcmp(index(3).subs{3},':')])==2
                    eval(sprintf('b(:,:) = oData.X.dk(%s,%s,%s);', index(3).subs{1}, index(3).subs{2}, index(3).subs{3}));
                else
                    eval(sprintf('b = oData.X.dk(%s,%s,%s);', index(3).subs{1}, index(3).subs{2}, index(3).subs{3}));
                end
            else
                error('use (:,:,:) to specify index')
            end
            
        end
    else
        error ('invalid index')
    end
else    
    error ('invalid index')
end
