function oModel = set(oModel,varargin)
% SET Set model properties and return the updated object
propertyArgIn = varargin;
while length(propertyArgIn) >= 2,
   prop = propertyArgIn{1};
   val = propertyArgIn{2};
   propertyArgIn = propertyArgIn(3:end);
   switch prop
      case 'tModelName'
                 % make the folder corresponding to new model
                path = 'C:\Users\bioSim\models\';
                f1=fullfile(path,val);
                if (exist(f1)==0)
                    mkdir(f1);
                end
                % moving the integrator to new location
                source = sprintf('%s\\%sODEIntegrator.m',oModel.tPath,oModel.tModelName);
                destination = sprintf('%s\\%sODEIntegrator.m',f1,val);
                eval(sprintf('movefile(\''%s'',\''%s\'',\''f\'');',source,destination));
                % removing the old Path and the the folder 
                eval (sprintf('rmpath %s;',oModel.tPath));
                eval (sprintf('rmdir(\''%s\'',\''s\'');',oModel.tPath));
                oModel.tModelName = val;
                oModel.tPath = sprintf('C:\\Users\\bioSim\\models\\%s',oModel.tModelName);
                % adding the Path of the new folder to matlab path
                eval (sprintf('addpath %s;',oModel.tPath));
            
      case 'vk'
                oModel.vk = val;
                
      case 'vX0'
                oModel.vX0 = val;
                
      case 'sT0'
                oModel.sT0 = val;
                
      case 'tODEFunction'
                oModel.tODEFunction = val;
                
      case 'tOutputExpression'
                oModel.tOutputExpression = val;
                
      case 'vlegend'
                oModel.vlegend = val;                
            
      case 'slk'
                error('cant change. Value depends on parameter vector');
                
      case 'slX'
                error('cant change. Value depends on initial condition vector');
                
      case 'tPath'
                oModel.tPath = val;
   
       otherwise
          error('Model properties:tModelName,vk,vX0,sT0,tODEFunction,tOutputExpression,legend,slk,slX,tPath')
   end
end
oModel.slk  = length(oModel.vk);
oModel.slX = length(oModel.vX0);
