function CreateFrameIntegrators(oModel)

%
% Create frames for integrators :
% - ODEIntegrator
% - CvodeIntegrator
% - StochIntegrator
% - VariationalIntegrator
% - ParameterVariationalIntegrator
%
%
%
% Version 1, october 2008
% Marc Hafner, EPFL-IC-LANOS, Switzerland
% help and comments to marc.hafner@epfl.ch
%

global PromptMode
if isempty(PromptMode)==1
    displayPromptModes();
    PromptMode = input('Please set PromptMode, 0-1: ');
end

files={'ODEIntegrator.m','CvodeIntegrator.cpp','StochIntegrator.cpp','VariationalIntegrator.m','ParameterVariationalIntegrator.m'};


SelectLibraryFolder;

if ~exist('LibraryFolder','var')
    disp(' ')
    disp('No Library folder selected')
    disp(' ')
    return
end
    
for i=1:length(files)
    eval(sprintf('Mfile = fopen(''%s/%s%s'');',oModel.tPath,oModel.tModelName, files{i}));

    if Mfile~=-1
        if PromptMode;
            fprintf('file ''%s%s'' already exists. ',oModel.tModelName, files{i});
            reply = input('Do you want to overwrite it y/n [n]? ', 's');
        else reply='n';end;
        if isempty(reply)==1 || reply=='N' || reply=='n'
            openfile(i)=0;
            continue;
        end
    end

    if Mfile==-1 || reply=='Y' || reply=='y'

        check = (files{i}=='.').*[1:length(files{i})];
        functionname = sprintf('Create%s',files{i}(1:max(check)-1));
        
        eval(sprintf('status = %s(oModel);',functionname));

        if status==1
            openfile(i)=1;
        end
    end

end


for i=1:length(openfile)
    if openfile(i)
        eval(sprintf('open(''%s/%s%s'')', oModel.tPath, oModel.tModelName, files{i}));
    end
end

