function Y = extractX(oData, expression)

% Y = extractX(oData [, expression] )
%
% extarct the expression of state variable from data or vector X.
% If no expression is given, extract the output (not possible for vector).
% Output can be simple combination of X1, X2, X3 where Xi has to be
% considerated as a vector (like 'X2.*X3'),
% or a full expression such as sum(X(:,[2 3]),2);
%
% See also DATA.
%
% Version 1, October 2008
% Marc Hafner, EPFL-IC-LANOS, Switzerland
% help and comments to marc.hafner@epfl.ch
%

if isa(oData,'data')
    if nargin==1
        expression = oData.Output;
    end

    if ndims(oData.X)==3
        X(:,:) = mean(oData.X,1);
    else
        X = oData.X;
    end
else
    if nargin==1 || ndims(oData)~=2
        error('Enter a class data object or a 2D-vector with an expression')
    end 
    X = oData;
end


lt = size(X,2);

for i=1:lt
    eval(sprintf('X%i = X(:,%i);', i, i));
end

eval(sprintf('Y = %s;',expression));