function h = plotks ( ks, varargin)

% 
% plotks(ks, options) can be used to plot a set of parameters with projections on all axis (log10 space). 
% It accepts the same options as MATLAB plot function.
%
% Version 1.1, november 2009
% Marc Hafner, EPFL-IC-LANOS, Switzerland
% help and comments to marc.hafner@epfl.ch
%

% if size(ks,1)>1
% vark = var(ks);
% kstoplot = sort((vark~=0).*[1:length(vark)],'descend');
% kstoplot = sort(kstoplot(1:max((kstoplot~=0).*[1:length(kstoplot)])));
% 
% ks = ks(:,kstoplot);
% else
%     kstoplot = 1:length(ks);
% end

kstoplot = 1:size(ks,2);

lk = size(ks,2);

ish = ishold;

nbplots = ceil(lk/2);

nbplotlines = ceil(nbplots/4);
nbplotcol = ceil(nbplots/nbplotlines);

if length(varargin)>0
    style = sprintf(', ''%s''',varargin{1});
    for i=2:length(varargin)
        if ischar(varargin{i})
            style = sprintf('%s, ''%s''',style,varargin{i});
        elseif length(varargin{i})>1
            style = sprintf('%s, [',style);
            for j=1:length(varargin{i})
                style = sprintf('%s %f ',style,varargin{i}(j));
            end
            style = sprintf('%s ]',style);
        else
            style = sprintf('%s, %f',style,varargin{i});
        end
    end
else
    style=', ''.''';
end

h.fig=gcf;
     
for i=1:floor(lk/2)
    
    h.sub{i}.f = subplot(nbplotlines, nbplotcol, i);
    if ish==1
        hold on
    else
        hold off
    end
    eval(sprintf('plot (ks(:,2*i-1), ks(:,2*i) %s)',style))
    set(gca,'XScale','log','YScale','log')
    eval(sprintf('h.sub{i}.xl = xlabel(''k_{%i}'');',kstoplot(2*i-1)));
    eval(sprintf('h.sub{i}.yl = ylabel(''k_{%i}'');',kstoplot(2*i)));
end

if mod(lk,2)==1
    i=i+1;
    h.sub{i}.f = subplot(nbplotlines, nbplotcol, i);
    if ish==1
        hold on
    else
        hold off
    end
    eval(sprintf('plot (ks(:,2*i-1), ks(:,2*i-2) %s)',style))
    set(gca,'XScale','log','YScale','log')
    eval(sprintf('h.sub{i}.xl = xlabel(''k_{%i}'');',kstoplot(2*i-1)));
    eval(sprintf('h.sub{i}.yl = ylabel(''k_{%i}'');',kstoplot(2*i-2)));
end