% install function for model Goodwin
% 
% launch file to install model and integrators files on the computer
% 
% version sept 08
 
load model.mat; 
 
SelectWorkingPath

if bioSimworkingpath(end)=='\' || bioSimworkingpath(end)=='/'
	bioSimworkingpath=bioSimworkingpath(1:end-1);
end
tPath = [bioSimworkingpath '/models/Goodwin']; 
if (exist(tPath,'dir')~=0) 
	reply=input('Folder for integrator already exist, overwrite y/n [n]?','s');

	if isempty(reply)==0 && (reply=='y' || reply=='Y')
		status=copyfile ('./integrators/*', [tPath '/'],'f');
	else
		status=1;
	end
else
	mkdir(tPath);
	status=copyfile ('./integrators/*', [tPath '/'],'f');
end
 
if status==0;
	disp('Error while copying files');
end
addpath(tPath);
oModel.tPath = tPath;
 
global DisplayMode 
if isempty(DisplayMode)==1
	displayDisplayModes();
	DisplayMode = input('Please set DisplayMode, 0-5: ');
end

Goodwin= oModel;
clear oModel

clear status tPath replay
disp('Installation of Goodwin completed')
