function [T,X] = GoodwinParameterVariationalIntegrator(vTimeRange, vk, vX0, options)

if nargin<3 || length(vk)~=6 || length(vX0)~=4 || length(vTimeRange)>3
	error('Incorrect arguments')
end

lX=4;
function dX = F(t,X)
	dX = X;

	 % ... write ODE for all variables 

	dX(1) = . . . ; % to be filled by hand !
	dX(2) = . . . ; % to be filled by hand !
	dX(3) = . . . ; % to be filled by hand !
	dX(4) = . . . ; % to be filled by hand !

end

function df = dFdX(t,X)
	df = zeros(lX,lX);

	 % ... write ODE derivates for all variables 

	df(1,1) = . . . ; % to be filled by hand !
	df(1,2) = . . . ; % to be filled by hand !
	df(1,3) = . . . ; % to be filled by hand !
	df(1,4) = . . . ; % to be filled by hand !

	df(2,1) = . . . ; % to be filled by hand !
	df(2,2) = . . . ; % to be filled by hand !
	df(2,3) = . . . ; % to be filled by hand !
	df(2,4) = . . . ; % to be filled by hand !

	df(3,1) = . . . ; % to be filled by hand !
	df(3,2) = . . . ; % to be filled by hand !
	df(3,3) = . . . ; % to be filled by hand !
	df(3,4) = . . . ; % to be filled by hand !

	df(4,1) = . . . ; % to be filled by hand !
	df(4,2) = . . . ; % to be filled by hand !
	df(4,3) = . . . ; % to be filled by hand !
	df(4,4) = . . . ; % to be filled by hand !


end

function dk = dFdk(t,X)
	dk = zeros(lX,lk);

	 % ... write ODE derivates for all variables 

	dk(1,1) = . . . ; % to be filled by hand !
	dk(1,2) = . . . ; % to be filled by hand !
	dk(1,3) = . . . ; % to be filled by hand !
	dk(1,4) = . . . ; % to be filled by hand !
	dk(1,5) = . . . ; % to be filled by hand !
	dk(1,6) = . . . ; % to be filled by hand !

	dk(2,1) = . . . ; % to be filled by hand !
	dk(2,2) = . . . ; % to be filled by hand !
	dk(2,3) = . . . ; % to be filled by hand !
	dk(2,4) = . . . ; % to be filled by hand !
	dk(2,5) = . . . ; % to be filled by hand !
	dk(2,6) = . . . ; % to be filled by hand !

	dk(3,1) = . . . ; % to be filled by hand !
	dk(3,2) = . . . ; % to be filled by hand !
	dk(3,3) = . . . ; % to be filled by hand !
	dk(3,4) = . . . ; % to be filled by hand !
	dk(3,5) = . . . ; % to be filled by hand !
	dk(3,6) = . . . ; % to be filled by hand !

	dk(4,1) = . . . ; % to be filled by hand !
	dk(4,2) = . . . ; % to be filled by hand !
	dk(4,3) = . . . ; % to be filled by hand !
	dk(4,4) = . . . ; % to be filled by hand !
	dk(4,5) = . . . ; % to be filled by hand !
	dk(4,6) = . . . ; % to be filled by hand !


end

% end of editable part of this file. Unless you want to optimize, leave
% the rest of this file original.

    function dX = FdFdk(t,X)
        dX = zeros(lX+lX*lk,1);
        
        dX(1:lX) = F(t,X(1:lX));
        df = dFdX(X(1:lX));
        dk = dFdk(X(1:lX));

        for i=1:lX
            for j=1:lk
                dX(lX+lk*(i-1)+j) = dk(i,j);
                for l=1:lX
                    dX(lX+lk*(i-1)+j) = dX(lX+lk*(i-1)+j) + df(i,l)*X(lX+lk*(l-1)+j);
                end
            end
        end
    end



vX0(end+1:lX+lX*lk) = 0;
 

if length(vTimeRange)==1
    X=FdFdk(vTimeRange,vX0);
    T=vTimeRange;
    return
else
    if length(vTimeRange)==3
        vTimeRange = [vTimeRange(1):vTimeRange(2):vTimeRange(3)];
    end
    if exist('options','var')
        [T,X]=ode45(@FdFdk,vTimeRange,vX0,options);
    else
        [T,X]=ode45(@FdFdk,vTimeRange,vX0);
    end
end

irelax = max([1; [1:length(T)]'.*(T<vTimeRange(1))]);
T=T(irelax:end);
X=X(irelax:end,:);
X(end,:)
end
